﻿using System;
using System.Threading;
using Microsoft.SPOT;
using Microsoft.SPOT.Hardware;
using SecretLabs.NETMF.Hardware.NetduinoPlus;

namespace TestNetduinoDS18B20
{
    public class Program
    {
        public static void Main()
        { 
            // DS18B20 connecté sur O5 du shield Tinkerkit          
            var Pin = new OutputPort(Pins.GPIO_PIN_D3,false);

            var DS18B20 = new OneWire(Pin);
            UInt16 temperature;

            // read every second
            while (true)
            {
                if (DS18B20.TouchReset()!=0) // Détection du circuit
                {
                    DS18B20.WriteByte(0xCC);     // Skip ROM, si un seul circuit
                    DS18B20.WriteByte(0x44);     // Lancement de la conversion

                    while (DS18B20.ReadByte() == 0) ;   // Attente fin de conversion

                    DS18B20.TouchReset();
                    DS18B20.WriteByte(0xCC);     // skip ROM
                    DS18B20.WriteByte(0xBE);     // Read Scratchpad

                    temperature = (byte)DS18B20.ReadByte();           // LSB 
                    temperature |= (UInt16)(DS18B20.ReadByte() << 8); // MSB

                    Debug.Print("Temperature: " + temperature / 16);
                    Thread.Sleep(1000);
                }
                else
                {
                    Debug.Print("Le circuit n'a pas été détecté.");
                }

                Thread.Sleep(1000);
            }
        }
    }
}
